﻿-- ------------------------------------------------------------------------
-- Set Up
-- ------------------------------------------------------------------------
local height = {
		["M"] = 28,		--player, target, focus
		["S"] = 15, 	--tot, focustarget
		["P"] = 15, 	--pet
		} 

local width = {
		["M"] = 144,	--player, target, focus
		["S"] = 122,	--tot, focustarget
		["P"] = 60,		--pet
		}

local Numberzzz = 0
local uiH = 400	--how high ur UF are positioned
local uiW = 250	--how wide ur UF are positioned

-- ------------------------------------------------------------------------
-- Colors rape
-- ------------------------------------------------------------------------
--{26/255, 255/255, 139/255}	- deff green
--{255/255, 191/255, 0/255}		- amber
--{173/255, 216/255, 230/255}	- angel blue
--{0/255, 255/255, 255/255}		- cyan

local m_color = {255/255, 191/255, 0/255}
local r_color = {255/255,70/255,42/255}

local colors = setmetatable({
	smooth = {r_color[1],r_color[2],r_color[3], r_color[1],r_color[2],r_color[3], r_color[1],r_color[2],r_color[3]},
	health = m_color,
	power = setmetatable({
		['MANA'] = m_color,
		['RAGE'] = m_color,
		['FOCUS'] = m_color,
		['ENERGY'] = m_color,
		['RUNIC_POWER'] = m_color,
	}, {__index = oUF.colors.power}),
--	runes = setmetatable({
--		[1] = {},
--		[2] = {},
--		[3] = {},
--		[4] = {},
--	}, {__index = oUF.colors.runes}),
		happiness = setmetatable({
		[1] = r_color,
		[2] = r_color,
		[3] = m_color,
	}, {__index = oUF.colors.happiness}),
}, {__index = oUF.colors})

-- ------------------------------------------------------------------------
-- Voodoo magic
-- ------------------------------------------------------------------------
local resFolder = "Interface\\AddOns\\Ieo_Res\\"
local texhp1 = resFolder.."status1.tga"
local texmp1 = resFolder.."status2.tga"

local font = resFolder.."main_font.ttf"
local fontS = 18
local fontF = "OUTLINE"
local scale = 0.9
--local fontF = nil

local buffborder = resFolder.."buffborder.tga"

local playerClass = select(2, UnitClass("player"))

-- ------------------------------------------------------------------------
-- Menus
-- ------------------------------------------------------------------------
local menu = function(self)
	local unit = self.unit:sub(1, -2)
	local cunit = self.unit:gsub("(.)", string.upper, 1)

	if(unit == "party" or unit == "partypet") then
		ToggleDropDownMenu(1, nil, _G["PartyMemberFrame"..self.id.."DropDown"], "cursor", 0, 0)
	elseif(_G[cunit.."FrameDropDown"]) then
		ToggleDropDownMenu(1, nil, _G[cunit.."FrameDropDown"], "cursor", 0, 0)
	end
end

-- ------------------------------------------------------------------------
-- Numbers magic
-- ------------------------------------------------------------------------
function round(num, idp)
  if idp and idp>0 then
    local mult = 10^idp
    return math.floor(num * mult + 0.5) / mult
  end
  return math.floor(num + 0.5)
end

function CoolNumber(num)
	if num>999 then
		return round(num/1e3,Numberzzz).."K"
	else
		return num
	end
end

-- ------------------------------------------------------------------------
-- More voodoo magic
-- ------------------------------------------------------------------------
local updateHealth = function(self, event, unit, bar, min, max)
	if(UnitIsDead(unit)) then
		bar:SetValue(0)
		bar.PERvalue:SetText("CND 0")
		bar.value:SetText"RIP"
	elseif(UnitIsGhost(unit)) then
		bar:SetValue(0)
		bar.PERvalue:SetText("CND 0")
		bar.value:SetText"GHO"
	elseif(not UnitIsConnected(unit)) then
		bar.PERvalue:SetText("CND 0")
		bar.value:SetText"OFF"
	elseif(unit == "player") then
		bar.value:SetText(CoolNumber(min))
	elseif(unit == "target")or(unit == "focus") then
		bar.PERvalue:SetText("CND"..(round(min/max, 2)*100))
		bar.value:SetText(CoolNumber(min))
	
	end
	
	bar.value:SetTextColor(m_color[1],m_color[2],m_color[3])
	bar.PERvalue:SetTextColor(m_color[1],m_color[2],m_color[3])
end

local updatePower = function(self, event, unit, bar, min, max)
	if(min == 0 or max == 0 or not UnitIsConnected(unit)) then
		bar.value:SetText()
		bar:SetValue(0)
	elseif(UnitIsDead(unit) or UnitIsGhost(unit)) then
		bar:SetValue(0)
	elseif(unit == "player") then
		bar.value:SetText(min.."/"..CoolNumber(max))
	elseif(unit == "target")or(unit == "focus") then
		bar.value:SetText(CoolNumber(min).."/")
	else
		bar.value:SetText(min.."/"..CoolNumber(max))
	end
	
	bar.value:SetTextColor(m_color[1],m_color[2],m_color[3])
end

-- ------------------------------------------------------------------------
-- Skinning buffs
-- ------------------------------------------------------------------------
local function PostCreateAuraIcon(self, button, icons, index, debuff)
	icons.showDebuffType = true -- show debuff border type color  
	
	button.icon:SetTexCoord(.07, .93, .07, .93)
	button.icon:SetPoint("TOPLEFT", button, "TOPLEFT", 1, -1)
	button.icon:SetPoint("BOTTOMRIGHT", button, "BOTTOMRIGHT", -1, 1)
	
	button.overlay:SetTexture(buffborder)
	button.overlay:SetTexCoord(0,1,0,1)
	button.overlay.Hide = function(self) self:SetVertexColor(0.3, 0.3, 0.3) end
	
	button.cd:SetPoint("TOPLEFT", button, "TOPLEFT", 2, -2) 
	button.cd:SetPoint("BOTTOMRIGHT", button, "BOTTOMRIGHT", -2, 2)
	button.cd:SetReverse()
end

-- ------------------------------------------------------------------------
-- Style
-- ------------------------------------------------------------------------
local function Style(self, unit)

	-- ------------------------------------------------------------------------
	-- Menu & register events
	-- ------------------------------------------------------------------------
	self.menu = menu
	
	self:SetScript("OnEnter", UnitFrame_OnEnter)
	self:SetScript("OnLeave", UnitFrame_OnLeave)
	
	self:RegisterForClicks("anyup")
	self:SetAttribute("*type2", "menu")
	
	-- ------------------------------------------------------------------------
	-- Health bar
	-- ------------------------------------------------------------------------
	self.Health = CreateFrame("StatusBar")
	self.Health:SetStatusBarTexture(texhp1)
	self.Health:SetParent(self)
	self.Health:SetHeight(18)

	self.Health:SetPoint("TOPLEFT", self, "TOPLEFT")
	self.Health:SetPoint("TOPRIGHT", self, "TOPRIGHT")

	self.Health.frequentUpdates = true
	self.Health.colorHealth = true
	self.Health.colorHappiness = true

	-- ------------------------------------------------------------------------
	-- Power bar
	-- ------------------------------------------------------------------------
	self.Power = CreateFrame("StatusBar")
	self.Power:SetStatusBarTexture(texmp1)
	self.Power:SetHeight(3)

	self.Power:SetParent(self)
	self.Power:SetPoint("BOTTOMLEFT", self, "BOTTOMLEFT")
	self.Power:SetPoint("BOTTOMRIGHT", self, "BOTTOMRIGHT")

	self.Power.frequentUpdates = true
	self.Power.colorPower = true
	self.Power.colorTapping = true

	-- ------------------------------------------------------------------------
	-- Text fields |cff00DBBA
	-- ------------------------------------------------------------------------
	self.Health.value = self.Health:CreateFontString(nil, "OVERLAY")
	self.Health.value:SetFont(font, fontS+8, fontF)
	
	self.Health.PERvalue = self.Health:CreateFontString(nil, "OVERLAY")
	self.Health.PERvalue:SetFont(font, fontS, fontF)

	self.Power.value = self.Power:CreateFontString(nil, "OVERLAY")
	self.Power.value:SetFont(font, fontS, fontF)
	
	self.Name = self.Health:CreateFontString(nil, "OVERLAY")
	self.Name:SetJustifyH("CENTER")
	self.Name:SetFont(font, fontS-2, fontF)
	self:Tag(self.Name, '[raidcolor][name]')

	-- ------------------------------------------------------------------------
	-- Raid icons
	-- ------------------------------------------------------------------------
	self.RaidIcon = self.Health:CreateTexture(nil, "OVERLAY")
	self.RaidIcon:SetTexture("Interface\\TargetingFrame\\UI-RaidTargetingIcons")
	self.RaidIcon:SetHeight(30)
	self.RaidIcon:SetWidth(30)

	-- ------------------------------------------------------------------------
	-- Auras system
	-- ------------------------------------------------------------------------
	self.Buffs = CreateFrame("Frame", nil, self)
	self.Buffs.initialAnchor = "TOPLEFT"
	self.Buffs["growth-y"] = "DOWN"
	self.Buffs:SetHeight(220)
	self.Buffs:SetWidth(180)
	self.Buffs.size = 21
	self.Buffs.spacing = 1
	
	self.Debuffs = CreateFrame("Frame", nil, self)
	self.Debuffs.initialAnchor = "BOTTOMLEFT"
	self.Debuffs["growth-y"] = "UP"
	self.Debuffs:SetHeight(75)
	self.Debuffs:SetWidth(180)
	self.Debuffs.size = 35
	self.Debuffs.spacing = 1
	self.Debuffs.onlyShowPlayer = 1

-- ------------------------------------------------------------------------
-- Individual frames setup
-- ------------------------------------------------------------------------

	-- ------------------------------------------------------------------------
	-- Player
	-- ------------------------------------------------------------------------
	if unit == "player" then
		local a = CreateFrame("Frame", nil, self)
		a:SetFrameStrata("BACKGROUND")
		a:SetFrameLevel(0)
		a:SetWidth(256)
		a:SetHeight(128)
		a:SetPoint("CENTER", self, "CENTER", 7, -7)
		a:Show()
		a.texture = a:CreateTexture(nil)
		a.texture:SetAllPoints(a)
		a.texture:SetTexture(resFolder.."bg1.tga")
		a.texture:SetVertexColor(m_color[1],m_color[2],m_color[3])

		self.Health.value:SetPoint("BOTTOMLEFT", self.Health, "TOPLEFT", -2, 0)
		self.Power.value:SetPoint("TOPLEFT", self.Power, "BOTTOMLEFT", -2, 0)
		
--		if playerClass == 'DEATHKNIGHT' then
--			RuneFrame:SetParent(self.Health)
--			RuneFrame:SetScale(.6)
--			RuneFrame:SetPoint('TOP', 0, 10)
--		end

		self:SetAttribute("initial-height", height.M)
		self:SetAttribute("initial-width", width.M)
	end

	-- ------------------------------------------------------------------------
	-- Target, Focus
	-- ------------------------------------------------------------------------
    if(unit == "target")or(unit == "focus") then
		local a = CreateFrame("Frame", nil, self)
		a:SetFrameStrata("BACKGROUND")
		a:SetFrameLevel(0)
		a:SetWidth(256)
		a:SetHeight(128)
		a:SetPoint("CENTER", self, "CENTER", -10, -9)
		a:Show()
		a.texture = a:CreateTexture(nil)
		a.texture:SetAllPoints(a)
		a.texture:SetTexture(resFolder.."bg2.tga")
		a.texture:SetVertexColor(m_color[1],m_color[2],m_color[3])

		self.Health.value:SetPoint("BOTTOMRIGHT", self.Health, "TOPRIGHT")
		self.Power.value:SetPoint("TOPRIGHT", self.Health.value, "TOPLEFT")
		
		self.Health.PERvalue:SetPoint("RIGHT", self.Power, "LEFT", -10, 0)

		self.Power:ClearAllPoints()
		self.Power:SetPoint("BOTTOM", self, "BOTTOM", 0, -14)
		self.Power:SetPoint("RIGHT", self, "RIGHT")
		self.Power:SetHeight(15)
		self.Power:SetWidth(71)
		
		self.Name:SetPoint("BOTTOMRIGHT", self, "TOPRIGHT", 0, 27)
		
		self.Buffs:SetPoint("TOPLEFT", self, "BOTTOMLEFT", -27, -30)
		self.Debuffs:SetPoint("BOTTOMLEFT", self, "TOPLEFT", -27, 30)

		self.RaidIcon:SetPoint("RIGHT", self, 35, -5)
		
		if ((playerClass == "ROGUE")or(playerClass == "DRUID"))and(unit == "target") then
			self.CPoints = self:CreateFontString(nil, "OVERLAY")
			self.CPoints:SetPoint("RIGHT", self, "LEFT", -50, 0)
			self.CPoints:SetFont(font, fontS+42, fontF)
			self.CPoints:SetTextColor(m_color[1],m_color[2],m_color[3])
			self.CPoints:SetJustifyH("RIGHT")
		end

		self:SetAttribute("initial-height", height.M)
		self:SetAttribute("initial-width", width.M)
    end
    
	-- ------------------------------------------------------------------------
	-- ToT, FoT
	-- ------------------------------------------------------------------------
	if(unit == "targettarget")or(unit == "focustarget") then
		local a = CreateFrame("Frame", nil, self)
		a:SetFrameStrata("BACKGROUND")
		a:SetFrameLevel(0)
		a:SetWidth(256)
		a:SetHeight(32)
		a:SetPoint("CENTER", self, "CENTER", 1, -7)
		a:Show()
		a.texture = a:CreateTexture(nil)
		a.texture:SetAllPoints(a)
		a.texture:SetTexture(resFolder.."bg3.tga")
		a.texture:SetVertexColor(255/255, 70/255, 42/255)

		self.Health:ClearAllPoints()
		self.Health:SetAllPoints(self)
		self.Health.colorSmooth = true
		self.Power:Hide()

		self.Name:SetPoint("BOTTOM", self, "TOP", 0, 0)
		
		self.Buffs:SetHeight(20)
		self.Buffs:SetWidth(160)
		self.Buffs.size = 19
		self.Buffs.num = 8
		self.Buffs:SetPoint("TOPLEFT", self, "BOTTOMLEFT", -20, -5)

		self:SetAttribute("initial-height", height.S)
		self:SetAttribute("initial-width", width.S)
	end
	
	
	-- ------------------------------------------------------------------------
	-- Pet
	-- ------------------------------------------------------------------------
    if (unit == "pet") then
		self.Health:ClearAllPoints()
		self.Health:SetStatusBarTexture(texmp1)
		self.Health:SetAllPoints(self)

		self.Power:Hide()
	
        self:SetAttribute("initial-height", height.P)
		self:SetAttribute("initial-width", width.P)
	end
	
	-- ------------------------------------------------------------------------
	-- Hello local functions
	-- ------------------------------------------------------------------------
	self.colors = colors
	self.PostUpdateHealth = updateHealth
	self.PostUpdatePower = updatePower
	self.PostCreateAuraIcon = PostCreateAuraIcon
	return self   
end

-- ------------------------------------------------------------------------
-- Register our layout
-- ------------------------------------------------------------------------
oUF:RegisterStyle("Ieo_Main", Style)
oUF:SetActiveStyle("Ieo_Main")

-- ------------------------------------------------------------------------
-- Spawning frames
-- ------------------------------------------------------------------------
oUF:Spawn("player", "oUF_Player"):SetPoint("BOTTOM", UIParent, "BOTTOM", uiW*(-1), uiH)
oUF:Spawn("pet", "oUF_Pet"):SetPoint("TOPRIGHT", oUF.units.player, "BOTTOMRIGHT", 0, -2)

oUF:Spawn("target", "oUF_Target"):SetPoint("BOTTOM", UIParent, "BOTTOM", uiW, uiH)
oUF:Spawn("focus", "oUF_Focus"):SetPoint("BOTTOM", UIParent, "BOTTOM", uiW*2, uiH)

oUF:Spawn("targettarget", "oUF_TargetTarget"):SetPoint("BOTTOM", UIParent, "BOTTOM", 0, uiH+7)
oUF:Spawn("focustarget", "oUF_FocusTarget"):SetPoint("BOTTOM", UIParent, "BOTTOM", 0, uiH+60)

oUF_Player:SetScale(scale)
oUF_Pet:SetScale(scale)
oUF_Target:SetScale(scale)
oUF_Focus:SetScale(scale)
oUF_TargetTarget:SetScale(scale)
oUF_FocusTarget:SetScale(scale)